routes/web.php
<?php

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

// Route::get('/', function () {
//   return redirect()->route('wvd.index');
// });

Auth::routes([
  'register' => false,
  'reset' => false,
  'verify' => false,
]);

Route::group(['prefix' => 'wvd', 'as' => 'wvd.', 'middleware' => 'auth'], function () {
  Route::get('/', 'WvdController@index')->name('index');
  Route::get('/data', 'WvdController@data')->name('data');
  Route::get('/add', 'WvdController@add')->name('add');
  Route::post('/add', 'WvdController@addConfirm')->name('addConfirm');
});

// Route::group(['prefix' => 'trigger/{uid}', 'as' => 'trigger.'], function () {
//   require 'triggerRoutes.php';
// });

// Route::get('/azure', 'AzureController@index')->name('azure');
// Route::get('/azure/data', 'AzureController@data')->name('azure.data');
// Route::post('/azure/action', 'AzureController@action')->name('azure.action');

app/Models/Wvd.php
<?php

namespace App\Models;

use Carbon\Carbon;
use App\Models\Trigger;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Facades\Log;

class Wvd extends Model
{

    protected $casts = [
        'daysofweek' => 'array',
    ];

    public function scopeActive($query)
    {
        return $query->where('autostart', 1);
    }

    public function triggers()
    {
        return $this->hasMany(Trigger::class, 'vm_name', 'vm_name');
    }

    public function addOnTrigger()
    {
        
        $startupTime =  Carbon::parse(Carbon::createFromFormat('H:i:s', $this->poweron_at, $this->timezone)->setTimezone('UTC')->format('H:i'));
        if($startupTime->isPast()) {
            $startupTime = $startupTime->addDay();  
        }

        return Trigger::updateOrCreate(
            [
                'vm_name' => $this->vm_name,
                'action' => 'start'
            ],
            [
                'resource_group' => $this->resource_group,
                'trigger_at' => $startupTime,
                'notified_at' => Carbon::now() // Important
            ]
        );
    }
    public function addOffTrigger()
    {
        $shutdownTime =  Carbon::parse(Carbon::createFromFormat('H:i:s', $this->poweroff_at, $this->timezone)->setTimezone('UTC')->format('H:i'));
        if($shutdownTime->isPast()) {
            $shutdownTime = $shutdownTime->addDay();  
        }
        

        return Trigger::firstOrCreate(
            [
                'vm_name' => $this->vm_name,
                'action' => 'deallocate'
            ],
            [
                'resource_group' => $this->resource_group,
                'trigger_at' => $shutdownTime,
                'notified_at' => Carbon::now()
            ]
        );
    }



    public function setLastUser($username)
    {
        $this->last_user = $username;
        // $this->save();
        return $this;
    }

    // public function getPoweroffTriggerAtAttribute()
    // {
    //     $trigger = $this->triggers->whereIn('action', ['deallocate', 'stop'])->first();
    //     return $trigger->trigger_at;
    // }

    // public function getPoweronTriggerAtAttribute()
    // {
    //     $trigger = $this->triggers->firstWhere('action', 'start');
    //     return $trigger->trigger_at;
    // }
}

app/Http/Controllers/WvdController.php
<?php

namespace App\Http\Controllers;

use App\Models\Wvd;
use Illuminate\Http\Request;

class WvdController extends Controller
{
    public function index() {
        return view('wvd.index');
    }

    public function data(Request $request)
    {
        $wvds = Wvd::all();       
        return \Yajra\DataTables\Facades\DataTables::of($wvds)->make(true);
    }

    public function add() {
        return view('wvd.add');
    }
    
    public function addConfirm(Request $request) {
        
        return $request->all();
    }
}

resources/views/wvd/add.blade.php
@extends('layouts.app')
@section('title', 'Dashboard')

@section('content_header')
<h1 class="m-0 text-dark">Add WVD</h1>
@stop

@section('content')
<section class="content">
    <div class="row">
        <div class="col-6 offset-md-3">
            <div class="card">
                <!-- /.card-header -->
                <form id="quickForm" method="POST">
                    @csrf
                    <div class="card-body">
                        <div class="form-group">
                            <label for="usernameInput">Username</label>
                            <input type="text" name="username" class="form-control" id="usernameInput"
                                placeholder="Ex: Vish">
                        </div>
                        <div class="form-group">
                            <label for="vmnameInput">VM Name<span class="text-danger">*</span></label>
                            <input type="text" name="vm_name" class="form-control" id="vmnameInput"
                                placeholder="Ex: AZ-IT-2">
                        </div>
                        <div class="form-group">
                            <label for="resourceGroupInput">Resource Group<span class="text-danger">*</span></label>
                            <input type="text" name="resource_group" class="form-control" id="resourceGroupInput"
                                placeholder="Ex: AZ-WVDPOOL-RG">
                        </div>
                        <div class="row">
                            <div class="form-group date col-6">
                                <label for="powerOffTimeInput">Power off at<span class="text-danger">*</span></label>
                                <input type="text" name="poweroff_at" class="form-control datetimepicker-input"
                                    id="powerOffTimeInput" data-toggle="datetimepicker" data-target="#powerOffTimeInput"
                                    placeholder="Ex: 10:00PM">
                            </div>
                            <div class="form-group date col-6">
                                <label for="powerOnTimeInput">Power on at<span class="text-danger">*</span></label>
                                <input type="text" name="poweron_at" class="form-control datetimepicker-input"
                                    id="powerOnTimeInput" data-toggle="datetimepicker" data-target="#powerOnTimeInput"
                                    placeholder="Ex: 10:00AM">
                            </div>
                        </div>
                    </div>
                    <div class="card-footer clearfix">
                        <button type="submit" class="btn btn-info float-right"><i class="fas fa-plus"></i> Save</button>
                    </div>
                </form>
            </div>
        </div>
    </div>
</section>
@endsection

@section('styles')
<link href="{{ asset('plugins/bootstrap-datetimepicker/css/tempusdominus-bootstrap-4.min.css') }}" rel="stylesheet">
@endsection

@section('scripts')
<script src="{{ asset('plugins/bootstrap-datetimepicker/js/tempusdominus-bootstrap-4.min.js') }}"></script>
<script src="{{ asset('plugins/jquery-validation/jquery.validate.min.js') }}"></script>
<script src="{{ asset('plugins/jquery-validation/additional-methods.min.js') }}"></script>

<script type="text/javascript">
    $(document).ready(function () {
      $.validator.setDefaults({
        
      });

      $('#quickForm').validate({
        submitHandler: function (form) {
            $(form).submit();
        },
        rules: {
          vm_name: {
            required: true,
          },
          resource_group: {
            required: true,
          },
          poweroff_at: {
            required: true
          },
          poweron_at: {
            required: true
          },
        },
        messages: {
          vm_name: 'VM name is required.',
          resource_group: 'Resource Group is required.',
          poweroff_at: 'Power off time is required.',
          poweron_at: 'Power on time is required.',
        },
        errorElement: 'span',
        errorPlacement: function (error, element) {
          error.addClass('invalid-feedback');
          element.closest('.form-group').append(error);
        },
        highlight: function (element, errorClass, validClass) {
          $(element).addClass('is-invalid');
        },
        unhighlight: function (element, errorClass, validClass) {
          $(element).removeClass('is-invalid');
        }
      });

        $('#powerOffTimeInput, #powerOnTimeInput').datetimepicker({
            format: 'LT'
        });
    });
</script>

@endsection

resources/views/wvd/index.blade.php
@extends('layouts.app')
@section('title', 'Dashboard')

@section('content_header')
<h1 class="m-0 text-dark">Manage WVDs</h1>
@stop

@section('content')
<section class="content">
    <div class="row">
        <div class="col-12">
            <div class="card">
                <div class="card-header">
                    {{-- <h3 class="card-title">DataTable with minimal features & hover style</h3> --}}
                    <a href="{{route("wvd.add")}}" class="btn btn-primary" href>Add New</a>
                </div>
                <!-- /.card-header -->
                <div class="card-body">
                    <table id="wvds-table" class="table table-bordered table-hover"></table>
                </div>
            </div>
        </div>
    </div>
</section>

<button type="button" class="btn btn-primary" data-toggle="modal" data-target="#addNewModal">
    Launch demo modal
</button>

<div class="modal fade" id="addNewModal" tabindex="-1" role="dialog" aria-labelledby="addNewModalLabel"
    aria-hidden="true">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="addNewModalLabel">Modal title</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
                <form>
                    <div class="form-group">
                        <label for="usernameInput">Username</label>
                        <input type="text" name="username" class="form-control" id="usernameInput"
                            placeholder="Ex: Vish"  value="{{ old('vm_name') }}">
                    </div>
                    <div class="form-group">
                        <label for="vmnameInput">VM Name</label>
                        <input type="text" name="vm_name" class="form-control" id="vmnameInput"
                            placeholder="Ex: AZ-IT-2" value="{{ old('vm_name') }}" autofocus>
                    </div>
                    <div class="form-group">
                        <label for="resourceGroupInput">Resource Group</label>
                        <input type="text" name="resource_group" class="form-control" id="resourceGroupInput"
                            placeholder="Ex: AZ-WVDPOOL-RG"  value="{{ old('resource_group') }}">
                    </div>
                    <div class="form-group">
                        <label for="powerOffTimeInput">Power off at</label>
                        <input type="text" name="poweroff_at" class="form-control" id="powerOffTimeInput"
                            placeholder="Ex: 10:00PM"  value="{{ old('poweroff_at') }}">
                    </div>
                    <div class="form-group">
                        <label for="powerOnTimeInput">Power on at</label>
                        <input type="text" name="poweron_at" class="form-control" id="powerOnTimeInput"
                            placeholder="Ex: 10:00AM"  value="{{ old('poweron_at') }}">
                    </div>
                </form>
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                <button type="button" class="btn btn-primary">Save changes</button>
            </div>
        </div>
    </div>
</div>
@endsection

@section('styles')
<link href="{{ asset('plugins/datatables-bs4/css/dataTables.bootstrap4.min.css') }}" rel="stylesheet">
<link href="{{ asset('plugins/datatables-responsive/css/responsive.bootstrap4.min.css') }}" rel="stylesheet">
@endsection

@section('scripts')
<script src="{{ asset('plugins/datatables/jquery.dataTables.min.js') }}"></script>
<script src="{{ asset('plugins/datatables-bs4/js/dataTables.bootstrap4.min.js') }}"></script>
<script src="{{ asset('plugins/datatables-responsive/js/dataTables.responsive.min.js') }}"></script>
<script src="{{ asset('plugins/datatables-responsive/js/responsive.bootstrap4.min.js') }}"></script>

<script>
    $(document).ready(function() {
    //     $("#example1").DataTable({
    //   "responsive": true,
    //   "autoWidth": false,
    // });
        var url = '{{route("wvd.data")}}';
        var packagesTable = $('#wvds-table').DataTable({
            processing: true,
            serverSide: true,
            autoWidth: false,
            responsive: true,
            pageLength: 20,
            order: [[ 7, 'desc' ]],
            ajax: url,
            lengthMenu: [[10, 20, 50, -1], [10, 20, 50, "All"]],
            columns: [                
                {data: 'tracking_number', width: '200px',  title: 'Tracking No', render: function ( data, type, row ) {
                    return `<a target="_blank" class="details-modal" href="${row.package_url}">${data}</a>&nbsp;&nbsp;
                            <a class="btn btn-sm btn-primary float-right" target="_blank" rel="noreferrer" href="${row.carrier_url}"><i class="fa fa-external-link" aria-hidden="true"></i></a>`
                }},
                {data: 'master_tracking_number', width: '150px', title: 'Master'},
                {data: 'shipper_city', title: 'From', width: '150px'},
                {data: 'recipient_city', title: 'To', width: '150px'},
                {data: 'recipient_city', title: 'Time Elapsed', width: '90px', render: function ( data, type, row ) {
                    return `<span data-toggle="tooltip" data-placement="top" title="${row.shipped_on}">` + moment.utc(row.shipped_on).fromNow(true)+ '</span>';
                }},
                {data: 'current_location', title: 'Current Location'},
                {data: 'status', title: 'Status', width: '150px', render: function ( data, type, row ) {
                    if(row.completed) {
                        return `<span class="badge badge-success">${data}</span>`;
                    }else if (row.exception) {
                        return `<span class="badge badge-danger">${data}</span>`;
                    }else {
                        return `<span class="badge badge-warning">${data}</span>`;
                    }
                }},
                {data: 'exception', title: 'Exception',width: '80px', render: function ( data, type, row ) {
                    if(data == 0) {
                        return 'No';
                    }
                    var excepionMessage = row.exception_action == null || row.exception_action == '' ? '': row.exception_action;
                    var showStar = excepionMessage == '' ? '': '*';
                    return `<b data-toggle="tooltip" data-placement="top" title="${excepionMessage}">Yes${showStar}</b>`;
                }},
                {data: 'est_delivery',width: '150px', title: 'Est Delivery', render: function ( data, type, row ) {
                    return data == null || data == '' ? 'Pending': moment.utc(row.updated_at).format('YYYY-MM-DD');
                }},
                {data: 'updated_at',width: '150px', title : 'Last Updated', render: function ( data, type, row ) {
                    return `<span data-toggle="tooltip" data-placement="top" title="${row.last_status_updated}">` + moment.utc(row.last_status_updated).fromNow()+ '</span>';                    
                }},
            ],
            rowCallback: function(row, data, displayNum, displayIndex, dataIndex ) {
                $(row).find('.details-modal').off().on('click', openDetailsPane);
                if(data.completed) {
                    $(row).addClass('table-success');
                }
                if(data.exception) {
                    $(row).addClass('table-danger');
                }
            },
            drawCallback: function(settings) {
                $(settings.nTable).find('[data-toggle="tooltip"]').tooltip()
            }
        })
        .on('processing.dt', function (e, settings, processing) {            
            if (processing) {
                $('#table-overlay').removeClass("d-none");
            } else {
                $('#table-overlay').addClass("d-none", true);
            }
        });
    });

</script>

@endsection